# cliff – Command Line Interface Formulation Framework

cliff is a framework for building command line programs. It uses plugins to define sub-commands, output formatters, and other extensions.

- Installation
  - Python Versions
  - Basic Installation
  - Source Code
  - Reporting Bugs
- Using cliff
  - Introduction
  - Exploring the Demo App
  - List Commands
  - Show Commands
  - Command Completion
  - Interactive Mode
  - Sphinx Integration
  - CHANGES
- Cliff Class Reference
  - Application
  - Formatting Output
- For Contributors
  - Running Tests
  - Building Documentation

Indices and tables

- Index

- Search Page

this page last updated: 2026-02-20 17:00:00

Except where otherwise noted, this document is licensed under Creative Commons Attribution 3.0 License. See all OpenStack Legal Documents.

found an error? report a bug